#include <windows.h>
#include <process.h>
#include <commctrl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "resource.h"
#include "protocol.h"
#include "util.h"

// Disable warning 'too long name' for standard c++ library
#pragma warning(disable: 4786)
// Disable warning 'decorated name length exceeded, name was truncated'
#pragma warning(disable: 4503)

#include <set>
#include <map>

class User {
protected:
	int m_nId;
	int m_nX;
	int m_nY;
	char m_szName[1024];
public:
	User(unsigned int nId,int nX,int nY,char* pszName)
	{
		m_nId = nId;
		m_nX = nX;
		m_nY = nY;
		strcpy(m_szName, pszName);
	}
	int X() { return m_nX; }
	int Y() { return m_nY; }
	void SetX(int nX) { m_nX = nX; }
	void SetY(int nY) { m_nY = nY; }
	char* Name() { return m_szName; }
};

#define MAINWNDCLASS "_CLIENTMAINWND_"
#define CLIENTWNDCLASS "_CLIENTWND_"
#define WM_USER_LOG (WM_USER + 0)
#define WM_USER_SOCKET (WM_USER + 1)
#define WM_USER_GETHOST (WM_USER + 2)

LONG APIENTRY WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
LONG APIENTRY ClientWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
LONG APIENTRY MyEditWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK DlgProc(HWND hWnd,UINT message, WPARAM wParam, LPARAM lParam);

void ReadSocket(SOCKET hSocket);

HWND g_hwndMain = NULL;
HWND g_hwndClient = NULL;
HWND g_hwndEdit = NULL;
HWND g_hwndLog = NULL;
HFONT g_hArialFont = NULL;
HANDLE g_hGetHostTask;
char g_szHostBuffer[MAXGETHOSTSTRUCT];
char g_szHost[1024] = "lunar";
SOCKET g_hSocket = NULL;
bool g_bConnected = false;
int g_nHostPort = 1001;
WNDPROC lpfnBaseButtonWndProc;
char g_szName[1024] = "test";
CRITICAL_SECTION g_csUser;
std::map<unsigned int,User*> g_mapUser;

int PASCAL WinMain(HINSTANCE hInstance,HINSTANCE hPrev,LPSTR lpszCmdLine,int cmdShow)
{
	WORD wVersion = MAKEWORD(1, 1);
	char szBuffer[1024];
    WSADATA wd;
	int nError;

    nError = WSAStartup(wVersion, &wd);

	if (nError != 0) {
		sprintf(szBuffer, "WinSock ʱȭ . ڵ=%d", nError);
		MessageBox(NULL, szBuffer, "", MB_OK);
		return 0;
	}
	if (LOBYTE(wd.wVersion) != 1 || HIBYTE(wd.wVersion) != 1) {
		sprintf(szBuffer, "WinSock 1.1 ã߽ϴ.");
		MessageBox(NULL, szBuffer, "", MB_OK);
		return 0;
	}		
	g_hSocket = socket(PF_INET, SOCK_STREAM, 0);

	if (g_hSocket == INVALID_SOCKET) {
		sprintf(szBuffer, "Socket µ ߽ϴ.");
		MessageBox(NULL, szBuffer, "", MB_OK);
		return 0;
	}

    WNDCLASS wc;
    MSG	msg;

    wc.style = CS_VREDRAW | CS_HREDRAW | CS_DBLCLKS;
    wc.lpfnWndProc = WndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_CLIENT));
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH) NULL;
    wc.lpszMenuName = MAKEINTRESOURCE(IDR_MENU);
    wc.lpszClassName = MAINWNDCLASS;

    if (RegisterClass((LPWNDCLASS) &wc) == false) {
        return(FALSE);
	}
    wc.style = CS_VREDRAW | CS_HREDRAW | CS_DBLCLKS;
    wc.lpfnWndProc = ClientWndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = 0;
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
    wc.lpszMenuName = 0;
    wc.lpszClassName = CLIENTWNDCLASS;

    if (RegisterClass((LPWNDCLASS) &wc) == false) {
        return(FALSE);
	}

	GetClassInfo(NULL, "edit", &wc);
    lpfnBaseButtonWndProc = (WNDPROC) wc.lpfnWndProc;
	wc.lpfnWndProc = MyEditWndProc;
    wc.hInstance = hInstance;
	wc.lpszClassName = "myedit";

    if (RegisterClass((LPWNDCLASS) &wc) == false) {
        return(FALSE);
	}

	g_hwndMain = CreateWindow(
		MAINWNDCLASS,
        "Client",
        WS_OVERLAPPEDWINDOW | WS_VISIBLE,
		0, 0, 550, 560,
		NULL,
		NULL,
        hInstance,
        NULL);

    while (GetMessage(&msg, NULL, 0, 0) ) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
    return msg.wParam;
}

BOOL CALLBACK DlgProc(HWND hWnd,UINT message, WPARAM wParam, LPARAM lParam)
{
	char szTemp[32];

	switch (message) {
	case WM_INITDIALOG :
		SetWindowText(GetDlgItem(hWnd, IDC_ADDRESS), g_szHost);
		itoa(g_nHostPort, szTemp, 10);
		SetWindowText(GetDlgItem(hWnd, IDC_PORT), szTemp);
		SetWindowText(GetDlgItem(hWnd, IDC_NAME), g_szName);
		break;
	case WM_COMMAND :
		if (wParam == IDOK) {
			GetWindowText(GetDlgItem(hWnd, IDC_ADDRESS), g_szHost, sizeof(g_szHost));
			GetWindowText(GetDlgItem(hWnd, IDC_PORT), szTemp, sizeof(szTemp));
			g_nHostPort = atoi(szTemp);
			GetWindowText(GetDlgItem(hWnd, IDC_NAME), g_szName, sizeof(g_szHost));
			EndDialog(hWnd, IDOK);
		}
		else if (wParam == IDCANCEL) {
			EndDialog(hWnd, IDCANCEL);
		}
		break;
	default :
		return FALSE;
	}
	return TRUE;
}

LONG APIENTRY WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	char szBuffer[1024];
    PAINTSTRUCT	ps;
	LOGFONT logfont;
	HDC hDC;

    switch (message) {
    case WM_CREATE :
		g_hwndClient = CreateWindowEx(WS_EX_CLIENTEDGE, CLIENTWNDCLASS, "", 
			WS_CHILD | WS_VISIBLE,
			0, 0, 0, 0,
			hWnd,
			(HMENU) 101,
			(HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
			NULL);
		g_hwndLog = CreateWindowEx(WS_EX_CLIENTEDGE, "listbox", "", 
			WS_CHILD | WS_VISIBLE | WS_VSCROLL | LBS_NOINTEGRALHEIGHT,
			0, 0, 0, 0,
			hWnd,
			(HMENU) 102,
			(HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
			NULL);
		g_hwndEdit = CreateWindowEx(WS_EX_CLIENTEDGE, "myedit", "",
			WS_CHILD | WS_VISIBLE | ES_LEFT,
			0, 0, 0, 0,
			hWnd,
			(HMENU) 103,
			(HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
			NULL);

		memset(&logfont, 0, sizeof(LOGFONT));
		logfont.lfCharSet = DEFAULT_CHARSET;
		logfont.lfHeight = -12;
		strcpy(logfont.lfFaceName, "Arial");
		g_hArialFont = CreateFontIndirect(&logfont);
		SendMessage(g_hwndLog, WM_SETFONT, (WPARAM) g_hArialFont, (LPARAM) 0);
		InitializeCriticalSection(&g_csUser);
		break;
    case WM_CLOSE :
		DestroyWindow(hWnd);
		break;
	case WM_SIZE :
		if (wParam != SIZE_MINIMIZED) {
			int cx = LOWORD(lParam);
			int cy = HIWORD(lParam);
			int nLog = 78;
			int nEdit = 20; 

			MoveWindow(g_hwndClient, 0, 0, cx, cy - (nLog + nEdit), TRUE);
			MoveWindow(g_hwndLog, 0, cy - (nLog + nEdit), cx, nLog, TRUE);
			MoveWindow(g_hwndEdit, 0, cy - (nEdit), cx, nEdit, TRUE);
		}
		break;
	case WM_USER_LOG :
		SendMessage(g_hwndLog, LB_ADDSTRING, 0, lParam);
		break;
    case WM_DESTROY :
		if (g_hArialFont != NULL) {
			DeleteObject(g_hArialFont);
		}
		DeleteCriticalSection(&g_csUser);
		PostQuitMessage(0);
        break;
	case WM_SETFOCUS :
		SetFocus(g_hwndEdit);
		break;
	case WM_COMMAND :
		if (wParam == ID_FILE_EXIT) {
			DestroyWindow(hWnd);
		}
		else if (wParam == ID_FILE_LOGIN) {
			HINSTANCE hInstance = (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE);

			if (DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG), hWnd, (DLGPROC) DlgProc) != IDOK) {
				return 0;
			}
			struct sockaddr_in addr;
			char szBuffer[1024];

			addr.sin_family = AF_INET;
			addr.sin_addr.s_addr = INADDR_ANY;
			addr.sin_port = 0;

			if (bind(g_hSocket, (struct sockaddr *) &addr, sizeof(addr)) == SOCKET_ERROR) {
				sprintf(szBuffer, "Socket bind .");
				MessageBox(NULL, szBuffer, "", MB_OK);
				DestroyWindow(hWnd);
				return 0;
			}
			if (g_szHost[0] >= '0' && g_szHost[0] <= '9') {
				addr.sin_family = AF_INET;
				addr.sin_addr.s_addr = inet_addr(g_szHost);
				WSAAsyncSelect(g_hSocket, hWnd, WM_USER_SOCKET, FD_CONNECT);

				if (connect(g_hSocket, (struct sockaddr*) &addr, sizeof(addr)) == SOCKET_ERROR) {
					int nError = WSAGetLastError();

					sprintf(szBuffer, "Socket connect . ڵ=%d", nError);
					MessageBox(NULL, szBuffer, "", MB_OK);
					DestroyWindow(hWnd);
					return 1;
				}
			}
			else {
				g_hGetHostTask = WSAAsyncGetHostByName(hWnd, WM_USER_GETHOST, 
					g_szHost, g_szHostBuffer, MAXGETHOSTSTRUCT);

				if (g_hGetHostTask == 0) {
					sprintf(szBuffer, "ȣƮ ̸ µ ߽ϴ.");
					MessageBox(NULL, szBuffer, "", MB_OK);
					DestroyWindow(hWnd);
					return 1;
				}
			}
		}
		else if (wParam == ID_FILE_LOGOUT) {
			closesocket(g_hSocket);
			g_hSocket = 0;
		}
		break;
	case WM_TIMER :
		break;
    case WM_PAINT :
        hDC = BeginPaint(hWnd, &ps);
        EndPaint(hWnd, &ps);
        break;
	case WM_USER_SOCKET :
		if (WSAGETASYNCERROR(lParam) != 0) {
			int nError = WSAGETASYNCERROR(lParam);

			sprintf(szBuffer, "socket . ڵ=%d", nError);
			MessageBox(NULL, szBuffer, "", MB_OK);
			DestroyWindow(hWnd);
			return 1;
		}
		switch (WSAGETSELECTEVENT(lParam)) {
		case FD_CONNECT:
		    WSAAsyncSelect(g_hSocket, hWnd, WM_USER_SOCKET, FD_READ);
			g_bConnected = true;
			break;
		case FD_READ :
			ReadSocket(g_hSocket);
			break;
		}
		break;
	case WM_USER_GETHOST :
		if (WSAGETASYNCERROR(lParam) != 0) {
			sprintf(szBuffer, "ȣƮ ̸ µ ߽ϴ.");
			MessageBox(NULL, szBuffer, "", MB_OK);
			DestroyWindow(hWnd);
			return 1;
		}
		else if (g_hSocket != 0) {
		    struct sockaddr_in addr;
			struct hostent *pHost = (struct hostent*) g_szHostBuffer;

			memset(&addr, 0x00, sizeof(addr));
			addr.sin_family = AF_INET;
			memcpy(&addr.sin_addr.s_addr, pHost->h_addr_list[0], pHost->h_length);
			addr.sin_port = htons(g_nHostPort);
		    WSAAsyncSelect(g_hSocket, hWnd, WM_USER_SOCKET, FD_CONNECT);

			if (connect(g_hSocket, (struct sockaddr*) &addr, sizeof(addr)) == SOCKET_ERROR) {
				int nError = WSAGetLastError();

				if (nError == WSAEWOULDBLOCK) {
				}
				else {
					sprintf(szBuffer, "Socket connect . ڵ=%d", nError);
					MessageBox(NULL, szBuffer, "", MB_OK);
					DestroyWindow(hWnd);
					return 1;
				}
		    }
		}
		break;
    default :
        return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return 0;
}

char* g_pszMap[] = {
//             1         2         3         4         5         6    
//	 0123456789012345678901234567890123456789012345678901234567890123456
	"+-----------------------------------------------------------------+", // 0
	"|                                                                 |", // 1
	"|                                                                 |", // 2
	"|                                                                 |", // 3
	"|     +---------+                             +----------+        |", // 4
	"|     |         |                             |          |        |", // 5
	"|     |         |             +-+                        |        |", // 6
	"|     |         |             | |             |          |        |", // 7
	"|     |         |             +-+             |          |        |", // 8
	"|     +---- ----+                             +----------+        |", // 9
	"|                                                                 |", // 10
	"|                                                                 |", // 11
	"|                                                                 |", // 12
	"|                                                                 |", // 13
	"|                                                                 |", // 14
	"|     +-----   ------+---------------------+-- ---------------+---+", // 15
	"|     |              |                     |                  |   |", // 16
	"|     |              |  ----------------+  +---------------   |   |", // 17
	"|     |              |                  |                     |   |", // 18
	"|     |              |  +------------+  +---------------------+   |", // 19
	"|     |              |  |                                     |   |", // 20
	"|     |              |  |               +------------------+  |   |", // 21
	"|     +-------+------+  +-----------+   |                  |  |   |", // 22
	"|             |                     |   +----------------  |  |   |", // 23
	"|             |                     |                      |      |", // 24
	"+-------------+---------------------+----------------------+------+", // 25
	NULL
};

LONG APIENTRY ClientWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    PAINTSTRUCT	ps;
	HDC hDC;
	int nI;
	int nY;
	static HFONT s_hFont = NULL;

	switch (message) {
	case WM_CREATE :
		{
/*			LOGFONT logfont;

			memset(&logfont, 0, sizeof(LOGFONT));
			logfont.lfCharSet = DEFAULT_CHARSET;
			logfont.lfHeight = -12;
			strcpy(logfont.lfFaceName, "ü");
			g_hArialFont = CreateFontIndirect(&logfont);
			SendMessage(hWnd, WM_SETFONT, (WPARAM) s_hFont, (LPARAM) 0);*/
		}
		break;
    case WM_CLOSE :
		DestroyWindow(hWnd);
		break;
	case WM_COMMAND :
		if (wParam == ID_FILE_EXIT) {
			DestroyWindow(hWnd);
		}
		break;
    case WM_PAINT :
        hDC = BeginPaint(hWnd, &ps);
		{
			HFONT hFont = (HFONT) GetStockObject(SYSTEM_FIXED_FONT);
			HFONT hOldFont = (HFONT) SelectObject(hDC, hFont);
			SIZE size;

			GetTextExtentPoint32(hDC, "H", 1, &size);

			for (nI = 0, nY = 0; g_pszMap[nI] != NULL; nI++, nY += size.cy) {
				TextOut(hDC, 0, nY, g_pszMap[nI], strlen(g_pszMap[nI]));
			}
			SelectObject(hDC, hOldFont);

			std::map<unsigned int,User*>::iterator i;
			User* pUser;

			EnterCriticalSection(&g_csUser);
			for (i = g_mapUser.begin(); i != g_mapUser.end(); i++) {
				pUser = i->second;

				TextOut(hDC, pUser->X() * size.cx, pUser->Y() * size.cy, "U", 1);
			}
			LeaveCriticalSection(&g_csUser);
		}
        EndPaint(hWnd, &ps);
        break;
    case WM_DESTROY :
		if (s_hFont != NULL) {
			DeleteObject(s_hFont);
		}
		PostQuitMessage(0);
        break;
	case WM_SETFOCUS :
		SetFocus(g_hwndEdit);
		break;
    default :
        return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return 0;
}

LONG APIENTRY MyEditWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) {
	case WM_KEYDOWN :
		if (g_hSocket == 0) {
			break;
		}
		if (wParam == VK_RETURN) {
			char szBuffer[1024];

			GetWindowText(hWnd, szBuffer, sizeof(szBuffer));
			SetWindowText(hWnd, "");

			if (szBuffer[0] != NULL) {
				char szPacket[1024];
				char* pPacket = szPacket + 2;

				pPacket = SetChar(pPacket, C_SAY);
				pPacket = SetString(pPacket, szBuffer);
				SetShort(szPacket, pPacket - szPacket);				
				send(g_hSocket, szPacket, pPacket - szPacket, 0);
			}
		}
		else if (wParam == VK_UP) {
			char szPacket[5];

			SetShort(szPacket, 4);
			SetShort(szPacket + 2, C_MOVE);
			SetShort(szPacket + 3, UP);
			send(g_hSocket, szPacket, 4, 0);
		}
		else if (wParam == VK_DOWN) {
			char szPacket[5];

			SetShort(szPacket, 4);
			SetShort(szPacket + 2, C_MOVE);
			SetShort(szPacket + 3, DOWN);
			send(g_hSocket, szPacket, 4, 0);
		}
		else if (wParam == VK_LEFT) {
			char szPacket[5];

			SetShort(szPacket, 4);
			SetShort(szPacket + 2, C_MOVE);
			SetShort(szPacket + 3, LEFT);
			send(g_hSocket, szPacket, 4, 0);
		}
		else if (wParam == VK_RIGHT) {
			char szPacket[5];

			SetShort(szPacket, 4);
			SetShort(szPacket + 2, C_MOVE);
			SetShort(szPacket + 3, RIGHT);
			send(g_hSocket, szPacket, 4, 0);
		}
		return 0;
	}
	return CallWindowProc(lpfnBaseButtonWndProc, hWnd, message, wParam, lParam); 
}

#define PACKET_BUFFER 1024

int g_nPI = 0;
int g_nRI = 0;
char g_szPacket[PACKET_BUFFER];
short g_sPacketLen = 0;
enum MODE { PACKET_LENGTH, PACKET_BODY };
MODE g_mode = PACKET_LENGTH;

void Packet(char* pPacket);

void ReadSocket(SOCKET hSocket)
{
	int nRead;

	while ((nRead = recv(hSocket, g_szPacket, PACKET_BUFFER - g_nPI, 0)) > 0) {
		g_nRI += nRead;

		while (g_nPI < g_nRI) {
			if (g_mode == PACKET_LENGTH) {
				if (g_nPI + 2 <= g_nRI) {
					g_sPacketLen = g_szPacket[0] + (g_szPacket[1] << 8) - 2;
					g_nPI += 2;
					g_mode = PACKET_BODY;
				}
				else {
					break;
				}
			}
			else if (g_mode == PACKET_BODY) {
				if (g_nPI + g_sPacketLen <= g_nRI) {
					if (g_szPacket[g_nPI] >= S_MAX) {
					}
					else {
						Packet(g_szPacket + g_nPI);
					}
					g_nPI += g_sPacketLen;
					g_mode = PACKET_LENGTH;
				}
			}
		}
		if (g_nPI == g_nRI) {
			g_nPI = g_nRI = 0;
		}
		else if (g_nPI > 0) {
			memmove(g_szPacket, g_szPacket + g_nPI, g_nRI - g_nPI);
			g_nRI -= g_nPI;
		}
	}
}

void Log(char* pszLog)
{
	int nIndex = SendMessage(g_hwndLog, LB_ADDSTRING, 0, (LPARAM) pszLog);
	int nCount = SendMessage(g_hwndLog, LB_GETCOUNT, 0, 0);

	if (nCount > 4) {
		SendMessage(g_hwndLog, LB_SETTOPINDEX, nCount - 4, 0);
	}
}

void Packet(char* pPacket)
{
	User* pUser;
	std::map<unsigned int,User*>::iterator i;
	unsigned int nId;
	char szLog[1024];

	switch (*pPacket++) {
	case S_MOVE :
		{
			int nX;
			int nY;

			pPacket = GetInteger(pPacket, (int&) nId);
			pPacket = GetInteger(pPacket, nX);
			pPacket = GetInteger(pPacket, nY);

			EnterCriticalSection(&g_csUser);
			i = g_mapUser.find(nId);
			if (i != g_mapUser.end()) {
				pUser = i->second;
				pUser->SetX(nX);
				pUser->SetY(nY);
			}
			LeaveCriticalSection(&g_csUser);
			InvalidateRect(g_hwndClient, NULL, FALSE);
		}
		break;
	case S_REMOVE :
		{
			pPacket = GetInteger(pPacket, (int&) nId);

			EnterCriticalSection(&g_csUser);
			i = g_mapUser.find(nId);
			if (i != g_mapUser.end()) {
				pUser = i->second;
				sprintf(szLog, "'%s' ̽ϴ.", pUser->Name());
				delete pUser;
				g_mapUser.erase(i);
			}
			LeaveCriticalSection(&g_csUser);
			InvalidateRect(g_hwndClient, NULL, FALSE);
			SendMessage(g_hwndLog, LB_ADDSTRING, 0, (LPARAM) szLog);
		}
		break;
	case S_SAY :
		{
			char szBuffer[512];
			
			pPacket = GetInteger(pPacket, (int&) nId);
			pPacket = GetString(pPacket, szBuffer, sizeof(szBuffer));

			EnterCriticalSection(&g_csUser);
			i = g_mapUser.find(nId);
			if (i != g_mapUser.end()) {
				pUser = i->second;
				sprintf(szLog, "%s: %s", pUser->Name(), szBuffer);
			}
			LeaveCriticalSection(&g_csUser);
			InvalidateRect(g_hwndClient, NULL, FALSE);
			Log(szLog);
		}
		break;
	case S_ATTACK :
		break;
	case S_ENTER :
		{
			char szName[1024];
			int nX;
			int nY;
			
			pPacket = GetInteger(pPacket, (int&) nId);
			pPacket = GetString(pPacket, szName, sizeof(szName));
			pPacket = GetInteger(pPacket, nX);
			pPacket = GetInteger(pPacket, nY);

			EnterCriticalSection(&g_csUser);
			User* pUser = new User(nId, nX, nY, szName);
			g_mapUser.insert(std::map<unsigned int,User*>::value_type(nId, pUser));
			sprintf(szLog, "'%s' ̽ϴ.", pUser->Name());
			LeaveCriticalSection(&g_csUser);
			InvalidateRect(g_hwndClient, NULL, FALSE);
			Log(szLog);
		}
		break;
	case S_LOG :
		{
			pPacket = GetString(pPacket, szLog, sizeof(szLog));
			Log(szLog);
		}
		break;
	case S_NAME :
		{
			char szPacket[1024];
			char* pszPacket = szPacket + 2;

			pszPacket = SetChar(pszPacket, C_NAME);
			pszPacket = SetString(pszPacket, g_szName);
			SetShort(szPacket, pszPacket - szPacket);
			send(g_hSocket, szPacket, pszPacket - szPacket, 0);
		}
		break;
	}
}
